%define module_name 	kqemu
%define version 		1.3.0
%define pre				pre9
%define distsuffix 		plf
%define release 		0.pre9.1

Name:			dkms-%{module_name}
Version:		%{version}
Release:		%mkrel %{release}
Summary:		DKMS-ready kernel-source for the QEMU accelerator module
License:		Freeware
Source:			%{module_name}-%{version}%{pre}.tar.bz2
Url:			http://fabrice.bellard.free.fr/qemu/qemu-accel.html
Group:			Emulators
Requires(pre):	dkms
Requires(post): dkms
Buildroot:		%{_tmppath}/%{name}-%{version}%{pre}-root
Exclusivearch:	%{ix86} x86_64
Conflicts:		dkms-qvm86

%description
The QEMU Accelerator Module increases the speed of QEMU when a PC is emulated
on a PC. It runs most of the target application code directly on the host
processor to achieve near native performance. It is very useful when you want
to run another Operating System (for example Windows) on a Linux desktop.

This package is in PLF because of Mandriva Linux policy forbidding non-free 
softwares.

%prep
%setup -q -n %{module_name}-%{version}%{pre}

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p %{buildroot}/usr/src/%{module_name}-%{version}
cp -a * %{buildroot}/usr/src/%{module_name}-%{version}
cat > %{buildroot}/usr/src/%{module_name}-%{version}/dkms.conf <<EOF
PACKAGE_VERSION="%{version}"

# Items below here should not have to change with each driver version
PACKAGE_NAME="%{module_name}"
MAKE[0]="cd \${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build ; make KERNEL_PATH=\${kernel_source_dir}"
CLEAN="cd \${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build ; make KERNEL_PATH=\${kernel_source_dir} clean"

BUILT_MODULE_NAME[0]="\$PACKAGE_NAME"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/%{module_name}/"

REMAKE_INITRD="no"
AUTOINSTALL=yes
POST_INSTALL="post-install"
POST_REMOVE="post-remove"
EOF

cat > %{buildroot}/usr/src/%{module_name}-%{version}/post-install <<EOF
grep '[^#]*%{module_name}' %{_sysconfdir}/modprobe.preload || echo %{module_name}>>%{_sysconfdir}/modprobe.preload
grep '%{module_name}' %{_sysconfdir}/modprobe.conf || echo "options %{module_name} major=0" >>%{_sysconfdir}/modprobe.conf
EOF
chmod +x %{buildroot}/usr/src/%{module_name}-%{version}/post-install

mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d/
cat > %{buildroot}%{_sysconfdir}/udev/rules.d/kqemu.rules <<EOF
KERNEL=="%{module_name}", SYMLINK="qvm86", MODE="0666"
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
dkms add -m %{module_name} -v %{version} --rpm_safe_upgrade
dkms build -m %{module_name} -v %{version} --rpm_safe_upgrade
dkms install -m %{module_name} -v %{version} --rpm_safe_upgrade
#Load it now so that we don't need to wait until next reboot 
rmmod %{module_name} > /dev/null 2>&1
modprobe %{module_name}

%preun
if [ $1 = 0 ]
then
	sed -i '/%{module_name}/d' /etc/modprobe.preload
	sed -i '/%{module_name}/d' /etc/modprobe.conf
fi
dkms remove -m %{module_name} -v %{version} --rpm_safe_upgrade --all ||:

%triggerpostun -- dkms-kqemu < 1.7.1.1-1plf
# Fix %%preun from old packages that removed the lines even on updates
grep '[^#]*%{module_name}' %{_sysconfdir}/modprobe.preload || echo %{module_name}>>%{_sysconfdir}/modprobe.preload
grep '%{module_name}' %{_sysconfdir}/modprobe.conf || echo "options %{module_name} major=0" >>%{_sysconfdir}/modprobe.conf

%files
%defattr(-,root,root)
%_usrsrc/%{module_name}-%{version}
%_sysconfdir/udev/rules.d/kqemu.rules

%changelog
* Thu Aug 03 2006 trem <trem@zarb.org> 1.3.0-0.pre9.1plf
- 1.3.0pre9

* Wed May 31 2006 Nicolas Lcureuil <neoclust@zarb.org>  1.3.0-0.pre7.2plf
- Fix udev rules

* Mon May 08 2006 trem <trem@zarb.org> 1.3.0-0.pre7.1plf
- 1.3.0pre7

* Fri May 05 2006 trem <trem@zarb.org> 1.3.0-0.pre6.1plf
- 1.3.0pre6
- add distsuffix
- add mkrel

* Sun Apr 23 2006 Pascal Terjan <pterjan@zarb.org> 0.7.2-3plf
- Add PLF reason

* Tue Oct 25 2005 Pascal Terjan <pterjan@zarb.org> 0.7.2-2plf
- Have post-install executable

* Mon Oct 10 2005 Erwan Velu <erwan.velu@free.fr>  0.7.2-1plf
- 0.7.2

* Sat Jul 30 2005 Pascal Terjan <pterjan@zarb.org> 0.7.1.1-1plf
- Drop P0 (fixed upstream)
- Don't remove the lines from modprobe.preload/modprobe.conf on update

* Mon Jul 25 2005 Pascal Terjan <pterjan@zarb.org> 0.7.1-3plf
- Add major=0 option in modprobe.conf

* Mon Jul 25 2005 Pascal Terjan <pterjan@zarb.org> 0.7.1-2plf
- Fix missing symbol (P0)

* Sun Jul 25 2005 Pascal Terjan <pterjan@zarb.org> 0.7.1-1plf
- 0.7.1

* Sun May 22 2005 Pascal Terjan <pterjan@zarb.org> 0.6.2_1-3plf
- Qemu is build for qvm86, so create a link to /dev/qvm86
- Preload the module, so that any user can use it
- Add Patch from Matthew Mastracci for device creation

* Thu May 12 2005 Pascal Terjan <pterjan@zarb.org> 0.6.2_1-2plf
- Only build on x86

* Wed May 11 2005 Pascal Terjan <pterjan@zarb.org> 0.6.2_1-1plf
- first Mandriva dkms package 
